# 基于el-menu的菜单组件（vue3版）
***vue3版本*** | [**vue2版本**](https://github.com/QuietHear/vue-ele-nav '右键新窗口浏览')


## 安装
	npm i vue-ele-nav-plus
	// 需要安装前置依赖组件，已安装请忽略
	npm i vue-router
	npm i element-plus
	// 开启国际化需要安装组件，已安装请忽略
	npm i vue-i18n

## 使用
	import vueEleNavPlus from "vue-ele-nav-plus";
	import "vue-ele-nav-plus/index.css";
	
	app.use(vueEleNavPlus);


## 0. 可改动样式变量
> 当前dom层级的vue-ele-nav-plus-box中！！！

* `--ele-nav-menu-height`：60px;-->嵌入DOM中的菜单高度

* `--ele-nav-text`：#303133;-->菜单字体颜色

* `--ele-nav-bg`：#fff;-->一级菜单背景色

* `--ele-nav-menu-bg2`：transparent;-->二级菜单背景色，建议使用菜单背景色less函数计算darken(x, 3%)

* `--ele-nav-menu-bg3`：transparent;-->三级菜单背景色，建议使用菜单背景色less函数计算darken(x, 6%)

* `--ele-nav-menu-bg4`：transparent;-->四级菜单背景色，建议使用菜单背景色less函数计算darken(x, 9%)

* `--ele-nav-menu-bg-hover`：#fef5e6;-->触摸菜单颜色，建议使用菜单背景色less函数计算lighten(x, 5%)

* `--ele-nav-menu-active`：var(--el-color-primary);-->点亮菜单颜色,默认取element主色

* `--ele-nav-colla-bg`：rgba(255, 255, 255, .2);-->收缩按钮背景色

> body中的vue-ele-nav-plus-poper中！！！

* `--ele-nav-menu-second-height`：40px;-->浮窗菜单高度

* `--ele-nav-text`：#303133;-->浮窗菜单字体颜色

* `--ele-nav-menu-bg2`：transparent;-->二级菜单背景色，建议使用菜单背景色less函数计算darken(x, 3%)

* `--ele-nav-menu-bg3`：transparent;-->三级菜单背景色，建议使用菜单背景色less函数计算darken(x, 6%)

* `--ele-nav-menu-bg4`：transparent;-->四级菜单背景色，建议使用菜单背景色less函数计算darken(x, 9%)

* `--ele-nav-menu-bg-hover`：#fef5e6;-->触摸菜单颜色，建议使用菜单背景色less函数计算lighten(x, 5%)

* `--ele-nav-menu-active`：var(--el-color-primary);-->点亮菜单颜色,默认取element主色


## 1. 参数
* `menu`：要显示的菜单数据-->Array;非必传;默认*[]*
>
	// 配置项说明
	{
		"name":'' // 菜单唯一值，对应路由的name
		"icon":{  // 菜单图标
			"attrs":{},
			"type":'',
			"icon":''
		}
		//
		// attrs的值会v-bind到对应dom上
		// type的值，有以下四种情况：
		// custom，此时为自定义组件,icon为组件名（！！！未内置，确保当前页面或全局已引入）
		// el，此时为el-icon,icon为图标组件名（！！！未内置，确保当前页面或全局已引入）
		// iconfont，此时为iconfont，icon为图标去掉icon-后部分（！！！未内置，确保当前页面或全局已引入）
		// 其他，此时为本地自定义图标，type为class，icon为内容
		//
		"title":'' // 菜单名
		"link":'' // 如果是外链菜单的话，传入地址
		"show":true // 是否展示在菜单中，只有设置为false才不展示
		"markName":'' // 次菜单不点亮，代替点亮的菜单name
		"children":[] // 子菜单，从顶层开始最深支持4层
	}
>

* `onlyShowFirst`：只展示菜单第一层-->Boolean;非必传;默认*false*
>
	会监听该参数：
	如果子菜单的第一层父菜单显示出来了，则会点亮第一层父级菜单
	如果子菜单的第一层父菜单隐藏了，则会点亮他的markName菜单
>

* `i18n`：标题是否开启国际化-->Boolean;非必传;默认*false*

* `showCollapsebtn`：纵向时是否展示收缩按钮-->Boolean;非必传;默认*true*

* `openBtn`：展开时的按钮-->Object;非必传;默认*{type:'el',icon:'Fold'}*
>
	attrs的值会v-bind到对应dom上
	type的值，有以下四种情况
	// custom，此时为自定义组件,icon为组件名（！！！未内置，确保当前页面或全局已引入）
	// el，此时为el-icon,icon为图标组件名（！！！未内置，确保当前页面或全局已引入）
	// iconfont，此时为iconfont，icon为图标去掉icon-后部分（！！！未内置，确保当前页面或全局已引入）
	// 其他，此时为本地自定义图标，type为class，icon为内容
>

* `closeBtn`：收起时的按钮-->Object;非必传;默认*{type:'el',icon:'Expand'}*
>
	attrs的值会v-bind到对应dom上
	type的值，有以下四种情况
	// custom，此时为自定义组件,icon为组件名（！！！未内置，确保当前页面或全局已引入）
	// el，此时为el-icon,icon为图标组件名（！！！未内置，确保当前页面或全局已引入）
	// iconfont，此时为iconfont，icon为图标去掉icon-后部分（！！！未内置，确保当前页面或全局已引入）
	// 其他，此时为本地自定义图标，type为class，icon为内容
>

* `popDark`：弹窗深色化-->Boolean;非必传;默认*false*
>
	无实际变化，只会给浮窗添加'dark'class
	为了应对非html.dark时组件仍深色的情况
>

* `@collapseChange`：点收缩按钮时触发-->无返回

* 其余参数与官网ele-menu相同


## 更多vue3组件
[**自定义右键菜单**](https://github.com/QuietHear/vue-diy-rightmenu-plus '右键新窗口浏览') | [**可拖拽菜单**](https://github.com/QuietHear/vue-drag-menu-plus '右键新窗口浏览') | [**echarts组件**](https://github.com/QuietHear/vue-echarts-block-plus '右键新窗口浏览') | ***基于el-menu的菜单组件*** | [**面包屑组件**](https://github.com/QuietHear/vue-permission-breads-plus '右键新窗口浏览') | [**滑动拼图**](https://github.com/QuietHear/vue-puzzle-slider-plus '右键新窗口浏览') | [**工作日历**](https://github.com/QuietHear/vue-shop-calendar-plus '右键新窗口浏览') | [**多页签组件**](https://github.com/QuietHear/vue-tabs-plus '右键新窗口浏览') | [**wangEditor**](https://github.com/QuietHear/vue-wangEditor-block-plus '右键新窗口浏览')